Subject: Re: bug#51062: Customizable window resizing

From: martin rudalics <[email-masked]>
Date: Tue, 4 Jan 2022 11:27:11 +0100

>> "shrink-buffer-if-larger-than-buffer"?  Maybe this should become
 >> 'shrink-buffer-window-if-larger-than-buffer' then.
 >
 > Should such a function be added to window.el?

Maybe.  But we could also rename the first argument of
'shrink-window-if-larger-than-buffer' to WINDOW-OR-BUFFER.

 >> With the usual problem what to do when there are two windows showing
 >> that buffer.
 >
 > It's understandable why vc-diff-internal and vc-diff-finish
 > use get-buffer-window to get a window:
 >
 > vc-diff-internal:
 >        (pop-to-buffer (current-buffer))
 >        (let ((buf (current-buffer)))
 >          (vc-run-delayed (vc-diff-finish buf ...
 >
 > vc-diff-finish:
 >    (let ((window (get-buffer-window buffer t)))
 >          (with-current-buffer buffer
 >            ...
 >            (when window
 >              (shrink-window-if-larger-than-buffer window))))
 >
 > This is needed to handle the case when the window was deleted
 > before the vc command finished.
 >
 > But why vc-log-internal-common doesn't so the same?
 >
 > vc-log-internal-common:
 >      (pop-to-buffer buffer)
 >      (vc-run-delayed
 >        ...
 >        (shrink-window-if-larger-than-buffer)
 >
 > So I posted a patch in bug#52855 to use the same function
 > that relies on get-buffer-window in both cases.
 >
 > But it seems you propose to remember the window with e.g.
 >
 >    (setq window (pop-to-buffer (current-buffer)))
 >
 > then to use it in:
 >
 >    (run-hook-with-args 'vc-diff-finish-functions window)
 >
 > where the defalut value of 'vc-diff-finish-functions' is:
 >
 >    '(shrink-window-if-larger-than-buffer)
 >
 > Then 'shrink-buffer-window-if-larger-than-buffer' is not needed.

Personally I dislike abusing hooks like that.  But I probably do not use
vc-... much either.  So do whatever you like more.

martin